#define SCL  PORTA.F0
#define SDA  PORTA.F1

#define SCLt TRISA.F0
#define SDAt TRISA.F1

#define ADDR 0xAA

unsigned char data;
unsigned char cnt;
unsigned char posX;
unsigned char posY;

void readByte(){
  cnt  = 0;
  data = 0;
  while(cnt < 8){
    while ( SCL);  //wait for SCL to go down
    while (!SCL);  //wait SCL to go high
    data = (data << 1) | SDA;
    cnt++;
  }
  __asm CLRWDT
}


void ack(){
  while(SCL);
  SDAt = 0;
  SDA = 0;
  while(!SCL); while(SCL);
  SDAt = 1;
}

void main(){
   SCLt = 1;
   SDAt = 1;
   CMCON = 0b00000111 ; //ALL Digital (comparators off)
   TRISB = 0;
   PORTB = 0;
   TRISA.F2 = 0;
   PORTA.F2 = 0;

   posX = 1;
   posY = 1;
   data = '-';
   Lcd_Custom_Config(&PORTB, 7, 6, 5, 4, &PORTB, 2, 1, 3);
   Lcd_Custom_Cmd(LCD_CLEAR);
   Lcd_Custom_Cmd(LCD_CURSOR_OFF);
   Lcd_Custom_Chr_Cp(data);

   __asm CLRWDT
   
   while(1){ //main loop
mainloop:
     SCLt = 1;
     SDAt = 1;
     while(! (SDA & SCL)) __asm CLRWDT;
     while (SDA) __asm CLRWDT ;
     if (SCL){ //START condition
         readByte(); // READ ADDRESS  (i2c id)

         //ACK if we are targeted   (ignore Read bit)
         if (data == ADDR ){
           ack();
         } else {
           goto mainloop;  // not for us, ignore it
         }

         readByte(); // Position
         ack();
         if (data < 16){
           posX = data+1;
           posY = 1;
         } else {
           posX = data-15;
           posY = 2;
         }

         readByte(); // READ DATA
         ack();
         SCLt = 0;     //Hold the clock line low
         SCL = 0;      //Untill you finish writing to LCD
         if (data == '\f') {
           Lcd_Custom_Cmd(LCD_CLEAR);
           posX = 1;
           posY = 1;
         } else if (data == '\n') {
           //Lcd_Custom_Cmd(LCD_SECOND_ROW);
           posY=2;
           posX=1;
         } else {
           Lcd_Custom_Chr(posY, posX, data);
           posX++;
         }
         SCLt = 1;

     } // if
     
   }// while
} // main
